package org.greenstone.gatherer.util;

import java.io.*;

public class StatusXML {

    static final private String FOOTER = "</Report>";
    static final private String HEADER = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>\n<?xml-stylesheet href=\"Report.xsl\" type=\"text/xsl\"?>\n<!DOCTYPE Walkthrough SYSTEM \"Report.dtd\">\n\n<Report>\n";
    static final private String[] PREFIX = {"  <Item>\n","    <ID>","    <Description>","    <ReportedBy>","    <Platform>","    <TestItem>","    <Status>","    <ProposedSolution>"};
    
    static final private String[] SUFFIX = {"  </Item>\n","</ID>\n","</Description>\n","</ReportedBy>\n","</Platform>\n","</TestItem>\n","</Status>\n","</ProposedSolution>\n"};

    static public void main(String[] args) {
	try {
	    BufferedReader in = new BufferedReader(new FileReader(new File("status.txt")));
	    FileOutputStream out = new FileOutputStream(new File("status.xml"));
	    out.write(HEADER.getBytes());
	    int line_count = 0;
	    String line = null;
	    while((line = in.readLine()) != null) {
		if(line.length() == 0) {
		}
		else {
		    if(line_count == 0) {
			out.write(PREFIX[line_count].getBytes());
			line_count++;
		    }
		    out.write(PREFIX[line_count].getBytes());
		    line = line.replaceAll("<", "&lt;");
		    line = line.replaceAll(">", "&gt;");
		    out.write(line.getBytes());
		    out.write(SUFFIX[line_count].getBytes());
		    line_count++;
		    if(line_count == PREFIX.length) {
			line_count = 0;
			out.write(SUFFIX[line_count].getBytes());
			out.write('\n');
		    }
		}
	    }
	    in.close();
	    in = null;
	    out.write(FOOTER.getBytes());
	    out.close();
	    out = null;
	}
	catch(Exception error) {
	    error.printStackTrace();
	}
    }
}
